function result=ProDiGe1(featureFile,posSet,varargin)

% Runs ProDiGe1. The function takes as input a file containing features for
% a set of positive and unlabeled examples and predicts scores for the
% unlabeled set.
% INPUT
% - featureFile : a mat-file name containing a Gram matrix named 'Kernel'
% - posSet : The indices of the positive examples
%
% OPTIONAL ARGUMENTS
% - C
% - NbScore
% - fileType
% - kernelType
% see help of functions fmethod and initialize for more details
%
% OUTPUT:
%  a vector of predicted scores for the unlabeled examples from Data
%  object, mean score and bootstrap subsamples.
%
% USAGE
% example use for the sixth disease (the fisrt one with at least two 
% positive examples), the indexes of the know associated genes are 1815 
% and 5057
% result=ProDiGe1('../data/newHprd/PPIdiffusion.mat',[1815 5057])

C=1;
NbScore=30;
normalizeFeatures=0;
fileType='mat';
kernelType= 'precomputed';

if ~isdeployed()
    addpath(genpath('../src/'))
end

% Parse optional arguments
l=1;
while (l<length(varargin))
    varargin{l} = varargin{l+1};
    l = l+2;
end

method = fmethod('baggingSVM', 'NbScore', NbScore, 'kernelType', kernelType,'C',C);

Data = initialize(featureFile,posSet,method,...
    'normalizeFeatures', normalizeFeatures, 'fileType', fileType);
clear method;
result=predict(Data);