function scores=MKLoneClass(Data)

% A function to perform 1class SVM with data fusion via MKL
%
% USE : score=MKLoneClass(Data)
%
% INPUT :
%  - Data : a structure containing the features, the positive examples and
%  various parameters, as initialized by initialize()
%
% OUTPUT : predicted scores of the 1class SVM trained with the combination
% of kernels learnt by the MKL


if ~isdeployed()
    addpath(genpath('../../MKLoneClass'))
end

% extract the list of kernels
Klist = cell(1,length(Data.feature));
Klist2 = cell(1,length(Data.feature));
Kernel=[];
for k=1:length(Data.feature)
    load(Data.feature{k},'Kernel')
    Klist{k} = Kernel(Data.posSet,Data.posSet);
    Klist2{k} = Kernel(Data.posSet,:);
end

% use Shi Yu's code to 'learn' the weights of the 8 kernels. The nu
% parameter of the 1class SVM is set to 0.5.
% theta   = the weights of the kernels
% alpha = the dual variables for the weight vector
[t,theta,alpha,spendtime] = one_class_Kinput_SOCP_L2(Klist,Data.method.param.C); %#ok<NASGU>

% compute combination kernel (only the train/test part)
K_train_test = zeros(length(Data.posSet),Data.nexample);
for k=1:length(Data.feature)
    K_train_test = K_train_test + theta(k)*Klist2{k};
end

% compute score
scores = (alpha'*K_train_test)';