function scores = predict(Data)

% scores = predict(Data)
%
% Predict new positives
%
% INPUTS:
%  - Data : a structure containing the features, the positive examples and
%  various parameters, as initialized by initialize(). The method
%  used to make inference should be in the 'method' field of this variable.
%
% OUTPUT:
%  a vector of scores
%
% SEE ALSO: functions 'initialize' and 'fmethod'

switch lower(Data.method.name)
    case 'baggingsvm'
        scores = predict_baggingsvm(Data);
        
    case 'baggingmkl'
        scores = predict_baggingmkl(Data);
        
    case 'mkl1class'
        scores = MKLoneClass(Data);
        
    case 'multisvm'
        scores = predict_multisvm(Data);
        
%     case 'multimkl'
%         scores = predict_multimkl(Data);
        
    otherwise
        disp('Unknown inference method!')
        scores = 0;
end

